using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using Microsoft.VisualStudio.Tools.Applications.Runtime;

public partial class _GetCustomers : System.Web.UI.Page {
	protected void btnGetCustomers_Click(object sender, EventArgs e) {
		string selectedRegionID = cboCustomers.SelectedItem.Text;

		//Response.Output.WriteLine("Selected State={0}<br>", selectedRegionID);
		getWorkbook(selectedRegionID);
	}

	private void getWorkbook(string regionID) {
		#region ADO.NET Goop -- Get List of Northwind Customers for Selected State
		// Load the dataset in the server application.
		string conn = ConfigurationManager.ConnectionStrings ["northwndConn"].ConnectionString;

		SqlCommand cmd = new SqlCommand("GetCustomersForRegion",  new SqlConnection(conn));
		cmd.CommandType = CommandType.StoredProcedure;
		cmd.Parameters.Add(new SqlParameter("@region", SqlDbType.NVarChar, 15));
		cmd.Parameters[0].Value = regionID;
		
		SqlDataAdapter da = new SqlDataAdapter(cmd);
		DataSet ds = new DataSet("dsCustomers");
		da.Fill(ds, "Customers");
		#endregion

		#region Get A Copy of The Template
		string masterDoc = Server.MapPath(@"CustomerTemplate.xls");

		#region Get Template File Byte[]
		byte [] origBytes;
		using (Stream fs = new FileStream(masterDoc, FileMode.Open)) {
			int size = (int)fs.Length;
			origBytes = new byte [size];

			using (BinaryReader br = new BinaryReader(fs)) {
				origBytes = br.ReadBytes(size);
			}
		}
		#endregion


		// Set a variable for the dataset in the worksheet.
		ServerDocument doc = new ServerDocument(origBytes, "customers.xls");

		#endregion

		#region Update the Data Island
		// Get the Cached DataSet XML Data Island
		CachedDataItem cdi = doc.CachedData.HostItems ["CustomerTemplate.Sheet1"].CachedData ["dsCustomers"];

		// Write the dataset to the currently empty 
		// cached dataset in the worksheet.
		cdi.SerializeDataInstance(ds);

		//Save the Updated XML Data Island
		doc.Save();
		#endregion

		#region Stream Back Response XLS file
		//Stream the XLS file back to the client browser
		Response.AddHeader("Content-dispostion", "filename=customers.xls");
		Response.ContentType = "application/vnd.ms-excel";
		Response.BinaryWrite(doc.Document);
		Response.End();
		#endregion

		//Close the Server Document (CLEANUP)
		doc.Close();
	}
}