using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.VisualStudio.Tools.Applications.Runtime;
using Word = Microsoft.Office.Interop.Word;
using Office = Microsoft.Office.Core;

namespace Demo1
{
    public partial class ThisDocument
    {
        [Cached]
        public DataSet dsCached;


        private void ReadEmployeeData()
        {
            if (dsCached == null)
            {
                MessageBox.Show("Employee data not cached.  Reading now.");
                dsCached = new DataSet();
                String dataPath = Environment.CurrentDirectory +
                    @"\data\employee.xml";
                dsCached.ReadXml(dataPath);
            }
            else MessageBox.Show("Using cached employee data");
        }

        private void ShowEmployeeData()
        {
            if (dsCached == null)
            {
                MessageBox.Show(
                    "No employee data available");
            }
            else
            {
                MessageBox.Show("Employee: " +
                    dsCached.Tables["employee"].Rows[0]["EmpName"].ToString());
            }
        }

        private void ThisDocument_Startup(object sender,
            System.EventArgs e)
        {
            //ReadEmployeeData();
            //ShowEmployeeData();

            ReadCustomerData();
            ShowCustomerData();
        }

        private void ThisDocument_Shutdown(object sender,
            System.EventArgs e)
        {
        }

        private void ReadCustomerData()
        {
            try
            {
                northwndDataSet dsNorthwind = new northwndDataSet();
                northwndDataSetTableAdapters.CustomersTableAdapter cta = new northwndDataSetTableAdapters.CustomersTableAdapter();
                cta.Fill(dsNorthwind.Customers);
                if (dsNorthwind != null) dsCached = dsNorthwind;
                MessageBox.Show("Online Mode\nCurrent customer data cached from database");
            }
            catch
            {
                if (dsCached == null)
                {
                    MessageBox.Show("Offline Mode\nNo cached customer data is available");
                }
                else
                {
                    MessageBox.Show("Offline Mode\nUsing cached customer data");
                }
            }
        }

        private void ShowCustomerData()
        {
            if (dsCached != null)
            {
                northwndDataSet dsNorthwind = (northwndDataSet)dsCached;
                MessageBox.Show("Customer: " +
                    dsNorthwind.Customers[0].ContactName.ToString());
            }
        }


        #region VSTO Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InternalStartup()
        {
            this.Startup += new System.EventHandler(ThisDocument_Startup);
            this.Shutdown += new System.EventHandler(ThisDocument_Shutdown);
        }
        
        #endregion

    }
}
